{    var   : }
{ N }
Unit MNK4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MN013_p, MN014_p, MN015_p, MNKU7_p, MN010_p, MN009_p, MNKP1_p,
MNKU2_p, MNKP0_p, MN012_p;

procedure MNK4R(var XF :Array of Real; var XE :Array of Real;
                var I0 :Array of Integer; var A :Array of Real;
                var B :Array of Real; var N :Integer; FUNC :Proc_F1_MN;
                var FF :Real; var FFE :Real; GRAD :Proc_F2_MN;
                var G :Array of Real; var GE :Array of Real;
                var UP :Array of Real; var RM :Array of Real;
                var IRM :Array of Integer; var W :Integer);

implementation

procedure MNK4R(var XF :Array of Real; var XE :Array of Real;
                var I0 :Array of Integer; var A :Array of Real;
                var B :Array of Real; var N :Integer; FUNC :Proc_F1_MN;
                var FF :Real; var FFE :Real; GRAD :Proc_F2_MN;
                var G :Array of Real; var GE :Array of Real;
                var UP :Array of Real; var RM :Array of Real;
                var IRM :Array of Integer; var W :Integer);
var
W0,NPI1,NI1I1,KMAX,KP,KP1,IPRINT,M1H,M1F,NXE1,NI1,NP,NCGE,NXT,NX,NHPR,
   K,NF,NG,M,I,NF0,NF1,NXTI1,NHPRKP,NHPRI1,LM :Integer;
EM,CAB1,CG,CAB,EFE,HE1,HA,HB,HT,FTE,FT,QG,H0,GMAX,Q2G,QP,HM,HAE,HBE,
   ETE,HA1,HB1 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22;
begin
{   EM-MAKCMAH OPOK ACOTHO BEH }
{   BEECTBEHHO KOHCTAHT; }
EM := 30;
{ HAAA HACTPOKA }
KMAX := Trunc(UP[0]);
KP := Trunc(UP[1]);
KP1 := Trunc(-1.0);
IPRINT := Trunc(UP[2]);
M1H := Trunc(UP[3]);
M1F := Trunc(UP[4]);
CAB1 := UP[5];
CG := UP[6];
CAB := FFE;
{   BEKTOP XE1 B MACCBE UP(HAHA C 8-O EK) }
NXE1 := 8;
NI1 := 4;
NP := 1;
NCGE := 1+N;
NXT := 1+2*N;
NX := 1+3*N;
NHPR := 1+4*N;
{   HACTPOKA AKOHEHA }
H0 := 10;
K := 0;
NF := 0;
NG := 0;
_1:
NF := NF+1;
FFE := CAB1;
FUNC(XF,FF,FFE);
EFE := FFE;
if ( CAB1 > FFE ) 
 then FFE := CAB1;
_2:
MN013(IRM[NI1-1],I0,N);
NG := NG+1;
MN014(G,IRM[NI1-1],GE,XF,FFE,UP[NXE1-1],CG,RM[NCGE-1],
     N,GRAD);
MN015(IRM[NI1-1],GMAX,A,B,XE,XF,G,N);
MNKU7(N,IRM[NI1-1],G,GMAX,QG,Q2G);
M := 0;
if ( Q2G = 0.0 ) 
 then goto _22;
for I:=1 to N do
 begin
  NPI1 := NP+I-1;
_3:
  RM[NPI1-1] := G[I-1];
 end;
QP := QG;
HE1 := Power(10.0,EM/2);
for I:=1 to N do
 begin
  if ( IRM[NI1+I-2] = 0 ) 
   then goto _4;
  NPI1 := NP+I-1;
  RM[NPI1-1] := RM[NPI1-1]/QP;
  HM := UP[NXE1+I-2]/Abs(RM[NP+I-2]);
  HE1 := EMin1(HE1,HM);
_4:
 end;
MN010(HA,HB,HAE,HBE,A,B,HE1,XF,UP[NXE1-1],IRM[NI1-1],
     RM[NP-1],N,EM);
M := 1;
if ( HE1 > HB ) 
 then goto _22;
if ( K = 0 ) 
 then HT := EMax1(5*HE1,0.01*QP);
MN009(N,NF0,IRM[NI1-1],RM[NP-1],QP,HA,HB,HE1,CAB1,XF,
     FF,FFE,HT,RM[NXT-1],FT,FTE,HA1,HB1,RM[NX-1],0.5,2.0,0.5,2.0,
     0.0,W0,FUNC);
if ( CAB1 > FTE ) 
 then FTE := CAB1;
NF1 := NF;
NF := NF+NF0;
M := 1;
if ( W0 = 0 ) 
 then goto _22;
if ( HB-HBE > HT ) 
 then goto _6;
NF := NF+1;
HT := HB;
for I:=1 to N do
 begin
  NI1I1 := NI1+I-1;
  if ( IRM[NI1I1-1] = 0 ) 
   then RM[NP+I-2] := 0.0;
  NXTI1 := NXT+I-1;
_5:
  RM[NXTI1-1] := XF[I-1]-HT*RM[NP+I-2];
 end;
FTE := CAB1;
FUNC(RM[NXT-1],FT,FTE);
ETE := FTE;
if ( CAB1 > FTE ) 
 then FTE := CAB1;
_6:
if ( FF-FT > FFE ) 
 then goto _7;
M := 1;
if ( FT-FF >= FFE ) 
 then goto _22;
M := 2;
goto _22;
_7:
K := K+1;
if ( KP = 0 ) 
 then goto _9;
if ( K = 1 ) 
 then goto _8;
if ( KP = KP1 ) 
 then goto _9;
if ( ((K) Mod (KP)) <> 0 ) 
 then goto _9;
_8:
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,
     FFE,G,GE,RM[NP-1],QG,RM[NHPR-1],1,1);
_9:
for I:=1 to N do
 begin
_10:
  XF[I-1] := RM[NXT+I-2];
 end;
FF := FT;
FFE := FTE;
EFE := ETE;
if ( KP <= 1 ) 
 then goto _12;
I := K-(K div KP)*KP;
if ( I <> 0 ) 
 then goto _11;
NHPRKP := NHPR+KP-1;
RM[NHPRKP-1] := HT;
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,
     FFE,G,GE,RM[NP-1],QG,RM[NHPR-1],KP,2);
goto _12;
_11:
NHPRI1 := NHPR+I-1;
RM[NHPRI1-1] := HT;
_12:
if ( K < KMAX ) 
 then goto _2;
_13:
IRM[0] := K;
IRM[1] := NF;
MNKU2(N,NG,I0,XF,G,GE,RM[NCGE-1],GRAD);
MNKU7(N,I0,G,1.0,QG,Q2G);
IRM[2] := NG;
if ( KP = 0 ) 
 then goto _14;
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,
     FFE,G,GE,RM[NP-1],QG,RM[NHPR-1],1,1);
if ( KP < 2 ) 
 then goto _14;
KP1 := K-(K div KP)*KP;
if ( KP1 < 2 ) 
 then goto _14;
KP1 := KP1-1;
MNKP1(IPRINT,N,NF,NG,K,IRM[NI1-1],XF,UP[NXE1-1],FF,
     FFE,G,GE,RM[NP-1],QG,RM[NHPR-1],KP1,2);
_14:
{   PEKPAEHE TEPAOHHOO POECCA }
if ( K-KMAX ) < 0
 then goto _16
 else if ( K-KMAX ) > 0
       then goto _15
       else goto _15;
_15:
W := 4;
goto _21;
_16:
if ( M1H+M1F ) < 0
 then goto _17
 else if ( M1H+M1F ) > 0
       then goto _18
       else goto _17;
_17:
W := 12;
goto _21;
_18:
if ( M1H ) < 0
 then goto _19
 else if ( M1H ) > 0
       then goto _20
       else goto _19;
_19:
W := 1;
goto _21;
_20:
W := 2;
_21:
if ( KP <> 0 ) 
 then MNKP0(IPRINT,W);
exit;
_22:
MN012(M1F,M1H,LM,CAB1,CAB,UP[NXE1-1],XE,M,N);
if ( LM ) < 0
 then goto _13
 else if ( LM ) > 0
       then goto _1
       else goto _13;
end;

end.
