Unit MNKU2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNKU2(N :Integer; var NG :Integer; var I1 :Array of Integer;
                var XF :Array of Real; var G :Array of Real;
                var GE :Array of Real; var CGE :Array of Real;
                GRAD :Proc_F2_MN);

implementation

procedure MNKU2(N :Integer; var NG :Integer; var I1 :Array of Integer;
                var XF :Array of Real; var G :Array of Real;
                var GE :Array of Real; var CGE :Array of Real;
                GRAD :Proc_F2_MN);
var
I :Integer;
label
_1,_2;
begin
{   BCEHE PAEHTA B TOKE XF }
I := 0;
_1:
I := I+1;
if ( I > N ) 
 then goto _2;
if ( I1[I-1] = 0 ) 
 then goto _1;
GE[I-1] := CGE[I-1];
goto _1;
_2:
GRAD(XF,G,GE,I1);
NG := NG+1;
end;

end.
